// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGDAMM_DATAMODELHASH_H
#define _LIBGDAMM_DATAMODELHASH_H


#include <glibmm.h>

// -*- C++ -*- // this is for the .hg, I realize gensig puts one in

/* datamodelhash.h
 *
 * Copyright 2007 libgdamm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>
#include <libgdamm/datamodelrow.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GdaDataModelHash GdaDataModelHash;
typedef struct _GdaDataModelHashClass GdaDataModelHashClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Gda
{ class DataModelHash_Class; } // namespace Gda

} // namespace Gnome
namespace Gnome
{

namespace Gda
{

/** An implementation of GdaDataModel based on a hash table.
 *
 * @ingroup DataModels
 */

class DataModelHash
 : public DataModelRow
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef DataModelHash CppObjectType;
  typedef DataModelHash_Class CppClassType;
  typedef GdaDataModelHash BaseObjectType;
  typedef GdaDataModelHashClass BaseClassType;

private:  friend class DataModelHash_Class;
  static CppClassType datamodelhash_class_;

private:
  // noncopyable
  DataModelHash(const DataModelHash&);
  DataModelHash& operator=(const DataModelHash&);

protected:
  explicit DataModelHash(const Glib::ConstructParams& construct_params);
  explicit DataModelHash(GdaDataModelHash* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~DataModelHash();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GdaDataModelHash*       gobj()       { return reinterpret_cast<GdaDataModelHash*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GdaDataModelHash* gobj() const { return reinterpret_cast<GdaDataModelHash*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GdaDataModelHash* gobj_copy();

private:

protected:
  explicit DataModelHash(int cols);

public:
  
  static Glib::RefPtr<DataModelHash> create(int cols);


  /** Sets the number of columns for rows inserted in this model.
   *  @a cols must be greater than or equal to 0. 
   * 
   * Also clears @a model's contents.
   * 
   * This function calls #gda_data_model_hash_clear to free the
   * existing rows if any.
   * @param cols The number of columns for rows inserted in @a model.
   */
  void set_n_columns(int cols);
  
  /** Frees all the rows inserted in @a model.
   */
  void clear();
  
  /** Inserts a @a row in the @a model.
   * @param rownum The number of the row.
   * @param row The row to insert. The model is responsible of freeing it!.
   */
  void insert_row(int rownum, const Glib::RefPtr<Row>& row);

  //gtkmmproc error: n-columns : property defs lookup failed.


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Gda
} // namespace Gnome


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gnome::Gda::DataModelHash
   */
  Glib::RefPtr<Gnome::Gda::DataModelHash> wrap(GdaDataModelHash* object, bool take_copy = false);
}


#endif /* _LIBGDAMM_DATAMODELHASH_H */

