// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGDAMM_DICTAGGREGATE_H
#define _LIBGDAMM_DICTAGGREGATE_H


#include <glibmm.h>

/* $Id: dictaggregate.hg,v 1.1 2006/05/08 10:18:53 murrayc Exp $ */
// -*- C++ -*- // this is for the .hg, I realize gensig puts one in

/* dictaggregate.h
 *
 * Copyright 2006 libgdamm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or(at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgdamm/object.h>
#include <libgdamm/xmlstorage.h>
#include <libgdamm/dicttype.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GdaDictAggregate GdaDictAggregate;
typedef struct _GdaDictAggregateClass GdaDictAggregateClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Gda
{ class DictAggregate_Class; } // namespace Gda

} // namespace Gnome
namespace Gnome
{

namespace Gda
{

class Connection;
class Dict;

/** Represents an aggregate in the DBMS (like COUNT() or AVG(), for example).
 * Because aggregates can be polymorphic, the name is not enough to identify them, so the DBMS provides a unique id which 
 * can be used to uniquely identify an aggregate.
 * 
 * @ingroup Dictionaries.
 */

class DictAggregate
: public Gda::Object,
  public XmlStorage
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef DictAggregate CppObjectType;
  typedef DictAggregate_Class CppClassType;
  typedef GdaDictAggregate BaseObjectType;
  typedef GdaDictAggregateClass BaseClassType;

private:  friend class DictAggregate_Class;
  static CppClassType dictaggregate_class_;

private:
  // noncopyable
  DictAggregate(const DictAggregate&);
  DictAggregate& operator=(const DictAggregate&);

protected:
  explicit DictAggregate(const Glib::ConstructParams& construct_params);
  explicit DictAggregate(GdaDictAggregate* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~DictAggregate();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GdaDictAggregate*       gobj()       { return reinterpret_cast<GdaDictAggregate*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GdaDictAggregate* gobj() const { return reinterpret_cast<GdaDictAggregate*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GdaDictAggregate* gobj_copy();

private:

  
protected:

 DictAggregate();

public:
  
  static Glib::RefPtr<DictAggregate> create();


  /** Set the DBMS identifier of the aggregate
   * @param id The DBMS identifier.
   */
  void set_dbms_id(const Glib::ustring& id);
  
  /** Get the DBMS identifier of the aggregate
   * @return The aggregate's id.
   */
  Glib::ustring get_dbms_id() const;
  
  /** Set the SQL name of the data type.
   */
  void set_sqlname(const Glib::ustring& sqlname);
  
  /** Get the DBMS's name of a data type.
   * @return The name of the data type.
   */
  Glib::ustring get_sqlname() const;
  
  /** Set the argument type of a aggregate
   * @param dt A Gda::DictType objects or #<tt>0</tt> value to represent the data type
   * of the aggregate's unique argument .
   */
  void set_arg_dict_type(const Glib::RefPtr<DictType>& dt);

  
  /** To consult the list of arguments types (and number) of a aggregate.
   * @return A list of Gda::DictType objects, the list MUST NOT be modified.
   */
  Glib::RefPtr<DictType> get_arg_dict_type();
  
  /** To consult the list of arguments types (and number) of a aggregate.
   * @return A list of Gda::DictType objects, the list MUST NOT be modified.
   */
  Glib::RefPtr<const DictType> get_arg_dict_type() const;

  
  /** Set the return type of a aggregate
   * @param dt A Gda::DictType object or #<tt>0</tt>.
   */
  void set_ret_dict_type(const Glib::RefPtr<DictType>& dt);

  
  /** To consult the return type of a aggregate.
   * @return A Gda::DictType object.
   */
  Glib::RefPtr<DictType> get_ret_dict_type();
  
  /** To consult the return type of a aggregate.
   * @return A Gda::DictType object.
   */
  Glib::RefPtr<const DictType> get_ret_dict_type() const;


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Gda
} // namespace Gnome


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gnome::Gda::DictAggregate
   */
  Glib::RefPtr<Gnome::Gda::DictAggregate> wrap(GdaDictAggregate* object, bool take_copy = false);
}


#endif /* _LIBGDAMM_DICTAGGREGATE_H */

